package Acme::BOPE;

require 5.005_62;
#use strict;
#use warnings;

our $VERSION =  0.01;

#use Exporter;
#
#our @ISA = qw(Exporter);
#our @EXPORT = qw(canta_hino fato);

my @ignoradas = (
  "[dn]?[oa][s]?"       , # o, a, os, as, dos, nos, das, nas, no, na, do, da
  "[nd]?e(?:ss|l)[ae]s?", # ele, ela, dele, dela, desse, dessa nesse, nessa
  "s(?:eu|ua)s?"        , # seu, sua
  "(?:uma?|eu)"         , # uma, eu
  "com"                 ,
  "sem"                 ,
  "porra[?!]*"          ,
  "merda[?!]*"          ,
  "viado[?!]*"          ,
);

#my $ignoradas = join "|", @ignoradas;

use Filter::Simple;

FILTER_ONLY
  all => sub {
  my $package = shift;
  my %par = @_;
  
  if ( $par{'DEBUG'} ) {
    filter($_);
    Perl::Tidy::perltidy(source => \$_, destination => \$_)
        if eval "require Perl::Tidy";
    print;
  }
#  my $DEBUG = $par{DEBUG} if $par{DEBUG};
#  return unless $DEBUG;
#  filter($_);
#  Perl::Tidy::perltidy(source => \$_, destination => \$_)
#   if eval "require Perl::Tidy";
#  print if $DEBUG;
#  exit;
},
  code_no_comments  => \&filter;
sub filter {

  $_ = "\$senhor = \$\$_;$/" . $_;
  $_ = "\$| = 1;$/" . $_;
  s#pelot[a]o, cantar hino#print Acme::BOPE::canta_hino#gi;
  s#Capit[a]o Nascimento#print Acme::BOPE::fato#gi; # mudar por frase legal

  s{\b(?:naum|no|nao|nunca|jamais)\s+(?:ser(?:|o)||eh)\b}{ne}gi;
  s{\b(?:naum|no|nao|nunca|jamais)\b}{not}gi;
  s{\bser(?:|o|a|ah|ao)\b}{eq}gi;
  s{\b(?:|eh)\b}{=}gi;
  s{\bfor\b}{eq}gi;

  s{\bvale(?:r)?\b}{==}gi;

  s{\bvai pra guerra\b}{system}gi;

  s#\bse\s+(.*?)\s+ent[a]o\b#if($1){\n#gi;
  s#\bent[a]o\b#\{#gi;
  s#\bfaz isso aqui[:]?\b#\{#gi;
  s#\bsen[a]o\b#}else{\n#gi;
  s#\bestamos entendidos[?!]*\b#}#gi;
  s#\bos? senhor(?:es)? est(?:[a]o|[a]) fazendo (?:o )?seu instrutor muito feliz(?:...)#}#gi;
  s{\bfala(?: agora)?[!:]*}{print}gi;
  s{\bgrita[!:]*\b}{print}gi;
  s{\bvai dar merda,?}{warn}gi;
  s{
    \b(?:v(?:ou|ai)\s+)?gritar\s+(?:em|n[oa]|ao?) (.*?):
   }
   {
    (my $file = $1) =~ s/\W/_/g;
    $file =~ s/^_+|_+$//g;
    my $fh = uc $file;
    "open $fh, \">>$file\";
     print \{$fh\}"
   }giex;

  s{\bchega[!]*\b}{last}gi;
  s{\bpra[!]*\b}{last}gi;

  s#\bpara\s+(.*?)\s+(?:ent[a]o|,)fa[c]a\b#for($1){#gi;
  s#\benquanto\s+(.*?)\s*,#while($1){\n#gi;

  s{\bfati(?:a|ou)\b}{split}gi;
  s{\bpass(?:a|ou)\b}{next}gi;

  s{\bpede pra sair\b}{die}gi;
  s{\b(?:eu )?desisto\b}{exit}gi;
  s{\bdesistiu\b}{= undef}gi;
  s{\bbota na conta do papa\b}{exit}gi;

  s{\be\b}{and}gi;
  s{\b(?:ent[a]o\s+)?senta o dedo nessa porra\b}{print "Caveira meu capitao!"}gi;
 
  # variaveis
  no warnings;
  s#\bsenhor(?:\s+(\d{2,}))?,#\$senhor = \\\$_$1;\n#gi;
  use warnings;
  s{\b(?:senhor|o)\s+(\d{2,})\b}{sprintf"\$_%s ", defined $1?$1:""}gie;
  s{([^\$])senhor|voc[e]}{$1\$\$senhor}gi;

  # perguntas
  s#(100\s*%\s+(\d{2,})?\?+)#
   print "$1";
   chomp(\$_$2 = <>);
   \$_$2 =~ /^100%|sim|s/ &&#gi;
  s#
    ((?:a?onde (?:es)t[a]|cad[e])\s+[oa]s?\s+(\w+)[?!]+)
   #
    my $var;
    ($var = $2) =~ s/\W/_/g;
    $var = lc($var);
    qq:
       print "$1";
       chomp(\$$var = <>);
       print "0" . (int(rand 9) + 1) . ", pega a vassoura!\$/";
      :;
   #gixe;

  my @quotes = m#"(.*?)"#gsm;
  s#"(.*?)"#sprintf qq/"%d"/, my $i++#gsme;

  # palavras que so ignoradas dentro do cdigo  
   foreach my $ignora (@ignoradas){
      s{\b$ignora\b}{}gi;
   }

  s#(?:(?:OK)?\s*[!?]+)#;#gi;
 
  s#"(\d+)"#"$quotes[$1]"#g;

};

# hinos do bope:
sub canta_hino {
    my $self = shift;
    my @hinos = (
         'O interrogatrio  muito fcil de fazer/pega o favelado e d porrada at doer/O interrogatrio  muito fcil de acabar/pega o bandido e d porrada at matar',
         'Esse sangue  muito bom/ j provei no tem perigo/ melhor do que caf/ o sangue do inimigo',
         'O quintal do inimigo/no se varre com vassoura/se varre com granada/com fuzil, metralhadora',
         'So os homens da caveira/do bornal e do cantil/Sua fora combativa/est na ponta do fuzil',
         'Cachorro latindo/Criana chorando/Vagabundo vazando/ o BOPE chegando',
         'Tropa de elite/osso duro de roer/Pega um, pega geral/tambm vai pegar voc',
         'Homem de preto, qual  sua misso?/Entrar pela favela e deixar corpo no cho/Homem de preto, o que  que voc faz?/Eu fao coisas que assustam o satans',
       );
    $hinos[int(rand(@hinos))];

}

# frases sobre o cap.nascimento
sub fato {
    my $self = shift;
    my @fatos = (
        'Deus disse que iria fazer o mundo em 7 anos. Capito Nascimento disse bem alto: "O senhor  um fanfarro, Sr. 01. O senhor tem 7 dias, sr. 01! SETE DIAS!"',
        'Quando vivia no paraso, Capito Nascimento forou Eva a comer a ma, dizendo: "Come a porra da ma 02! T com nojinho, 02? Come tudo, porra!"', 
        'A farda do Capito Nascimento  preta porque nenhuma outra cor quis ficar perto dele.',
        'O Capeta queria entrar no BOPE, mas o Capito Nascimento fez ele desistir apenas dizendo: "666, o senhor  o novo xerife!"',
        'O Capeta vendeu a alma para o Capito Nascimento.',
        'Capito Nascimento no sai de lugar nenhum devendo a ningum, sempre pe na conta do Papa.',
        'Quando Deus disse "Que se faa a luz!". Capito Nascimento falou "T de sacanagem, Sr. 01? T com medinho do escuro, Sr. 01?"',
        'Quando Deus resolveu criar o Universo foi pedir permisso ao Capito Nascimento e ele respondeu: " 100%? Ento senta o dedo nessa porra!"',
        'A roupa do Super-Homem era preta at o Capito Nascimento dizer: "Tira essa roupa preta que voc no  caveira, voc  MOLEQUE, ouviu? MO-LE-QUE!"',
        'Capito Nascimento trabalhou como negociador da polcia. Seu trabalho era ligar para os seqestradores e dizer: "Pede pra sair, porra!"',
        'Quantos Capites Nascimento so necessrios para trocar uma lmpada? Nenhum, Capito Nascimento tambm mata no escuro.',
        'Capito Nascimento no l livros, ele os coloca no saco at conseguir toda a informao que precisa.',
        'Uma vez ele esqueeu onde deixou as chaves do seu caveiro. Ele se colocou no saco por 40 segundos e lembrou!',
        'No existiam mesmo armas de destruio em massa no Iraque. Capito Nascimento mora no Rio de Janeiro.',
        'Porque voc acha que no existe terrorismo no Brasil?',
        'Nunca, em nenhuma hipotese, durma na frente do Capito Nascimento. Ele vai pedir pra voc fazer a bondade de segurar a granada.',
        'Em um de seus mandamentos, Deus disse: "No Matars". O Capito Nascimento disse para Deus: "T de sacanagem, Sr. 01? C t de sacanagem comigo, Sr. 01?"',
        'No houve impeachment no Governo Collor. O Capito Nascimento chegou no Palcio do Planalto e disse para o Collor:: "Pede pr sair!! Pede pr sair!!"',
        'No dia de So Cosme e So Damio, o Capito Nascimento s pegava saco de doce que tivesse chiclete de Caveira.',
        'Capito Nascimento fez com que o Seu Madruga pagasse o aluguel - todos os 14 meses atrasados - e adiantasse mais dois.',
        'Capito Nascimento foi ao programa do Fausto e fez com que ele falasse enquanto o fausto ficava calado.',
        'Capito Nascimento gritou no centro de Buenos Aires que Pel  o rei do futebol e todos os argentinos concordaram.',
        'Capito Nascimento fez um operador de telemarketing dizer: "desculpa, juro que no ligo mais".',
        'Capito Nascimento resolve o travamento do Windows colocando o PC no saco.',
        'Capito Nascimento disse pra Will Smith depois de ver "MIB": O senhor  um fanfarro! Homens de Preto  o caralho, s o BOPE usa preto! Seu viado!',
        'Capito Nascimento dorme com um travesseiro debaixo de uma arma.',
        'Capito Nascimento sabe exatamente onde est Carmen Sandiego',
        'Principais causas de morte no Brasil: 1. Ataque do corao, 2. Cap. Nascimento, 3.Cncer; mas a opo 1  maior porque a maioria dos bandidos morre do corao quando vem o capito.',
       );
    print $fatos[int(rand(@fatos))];
}

42;

__END__

=head1 NAME

Acme::BOPE.pm - Programe armado, cumpadi, e de farda preta.

I<Note: this Acme module lets you program the way the BOPE (brazilian police's special operations squad) policemen talk in the movie "Tropa de Elite". Since its intended audience have to understand portuguese in order to enjoy the module, the rest of the documentation is all in pt_BR. Have fun! Oh, also, this is not to be taken seriously, nor does it expresses the opinion of any of the involved people, nor is oficially linked to the movie.>

B<Esse mdulo foi feito como uma brincadeira em relao ao filme "Tropa de Elite", e no deve ser levado  srio. Nada do que est escrito aqui expressa a opinio dos autores ou qualquer outro envolvido direta ou indiretamente com o mesmo, e no h qualquer tipo de ligao oficial com o filme. Divirtam-se!>



=head1 VERSO

Verso 0.01



=head1 SINOPSE

   use Acme::Bope;
  
E a partir da poder escrever seus programas assim:

   Senhor 01, o senhor eh um "fanfarrao"!
   se o senhor for "moleque" entao pede pra sair "seu viado"! 
   senao senta o dedo nessa porra e bota na conta do Papa!
   vai dar merda, "vai morrer gente...";
   
   O 01 DESISTIU!!!
   
   Os senhores estao fazendo o seu instrutor muito feliz...

que  mais ou menos equivalente a:

   $_01 = "fanfarrao";
   if ($_01 eq "moleque") {
      die "seu viado";
   }
   else {
      print "Caveira, meu capitao!\n" and exit;
      warn "vai morrer gente";

      $_01 = undef;
   }

Voc ainda pode dar o comando para ouvir seu peloto...quer dizer, seu programa... cantar um dos famosos hinos do BOPE:

    Peloto, cantar hino!
    # Cachorro latindo/Criana chorando/Vagabundo vazando/ o BOPE chegando

Essa verso possui 7 hinos cadastrados. Se voc souber de outro, grite!

E, se voc tem alguma dvida sobre o seu capito, basta citar o nome dele pra ouvir um dos fatos:

    Capito Nascimento?
    # Capito Nascimento dorme com um travesseiro debaixo de uma arma.

Essa verso possui 28 "fatos" cadastrados. Se voc souber de outro, grite! E antes que algum pergunte, no vamos incluir nenhum fato que seja "compartilhado" com Chuck Norris ou Jack Bauer, porque eles so MOLEQUES!



=head1 DESCRIO

Criado na base do morro da Babilnia, Rio de Janeiro, em plena noite de baile funk, este mdulo permite que os senhores faam incurses de programao Perl usando apenas jarges e linguagens retiradas do famoso filme 'Tropa de Elite' de Jos Padilha, com estratgia e sem fanfarronice. Isso , se vocs conseguirem. Seno, pede pra sair... e bota na conta do Papa.


=head1 EQUIVALNCIAS

Caso ainda seja novo no batalho, aqui vo algumas equivalncias:

=over 4

=item * I<(print)> - fala, grita

=item * I<(warn "MENSAGEM")> - vai dar merda "MENSAGEM"

=item * I<(system "COMANDO")> - vai pra guerra "COMANDO"

=item * I<(split)> - fatia, fatiou

=item * I<(next)> - passa, passou

=item * I<(last)> - chega!!! pra!!!

=item * I<(die)> - pede pra sair

=item * I<(exit)> - desisto, eu desisto, bota na conta do papa

=back

Blocos podem ser escritos de forma simples e direta:

    faz isso aqui:
        ...
    estamos entendidos?
    # ou ainda: os senhores esto fazendo o seu instrutor muito feliz

 o mesmo que:

    {
        ...
    }

Condicionais so feitos assim:

    se EXPRESSO ento
        ...
    seno
        ...
    estamos entendidos?

 o mesmo que:

    if (EXPRESSO) {
        ...
    }
    else {
        ...
    }

Voc pode tambm usar laos (lao de homem, nada de ficar botando lacinho nos seus programas!!!):

   para (...) ento, faa
      ...
   estamos entendidos?

 o mesmo que:

   for (...) {
      ...
   }

ou ainda:

   enquanto (...)
      ...
   estamos entendidos?

 o mesmo que:

   while (...) {
      ...
   }

Lembrando que comparaes podem ser feitas assim:

   ne      nunca sero, jamais sero, no , no ser, jamais ser
   not     no, nunca, jamais
   eq      ser, sero, for
   ==      vale, valer


 possvel ainda adicionar uma srie de palavras adicionais para deixar seu cdigo mais "legvel", e impor a ordem entre esses programadores fanfarres.

=over 4

=item * o, a, os, as, no, na, nos, nas, do, da, dos, das

=item * ele, ela, eles, elas, dele, dela, deles, delas, desse, dessa, desses, dessas, nesse, nessa, nesses, nessas

=item * seu, sua, seus, suas

=item * eu

=item * com, sem

=item * porra, merda, viado (e pode adicionar quantas interrogaes ou exclamaes quiser depois)

=back 

=head1 MAISCULAS E ACENTOS

No linguajar do Bope, nenhuma palavra  sensvel a caixa. Voc pode sussurar comandos ou gritar com vagabundos, tudo funciona. Exemplos:



=head1 DIAGNSTICO

Se voc acha que fez m#$%@ e quer ver o cdigo equivalente em Perl (em vez de simplesmente executar seu programa intil), passe o parmetro C<DEBUG> para o mdulo:

   use Acme::BOPE DEBUG => 1;

Quanto tempo voc precisa pra depurar? 10 minutos???? Fanfarro.



=head1 DEPENDNCIAS

Tu  dependente, mermo????? Se quiser ver o cdigo de debug cheio de frufru, instala o Perl::Tidy que  100%.

Ah, e se os senhores no tiverem o Filter::Simple instalado, nunca sero...



=head1 BUGS

Provavelmente um monte. Se encontrar algum, avisa via RT. Mas sem fanfarrice, estamos entendidos?

(temos ainda que atualizar a documentao do mdulo para incluir variveis


=head1 AUTORES

Breno G. de Oliveira C<< <garu at cpan.org> >> e Fernando Corra C<< <fco at cpan.org> >>

Esse mdulo foi feito como uma brincadeira dentro da comunidade Perl sobre o filme Tropa de Elite, na semana de lanamento do filme. Apresentamos durante o YAPC::Brasil 2007 e o pessoal gostou tanto que encheu a nossa pacincia para botarmos no ar. Ta.


=head1 RECONHECIMENTOS E AGRADECIMENTOS

O cdigo foi fortemente baseado no L<Acme::Lingua::Strine::Perl> do Simon Wistow C<simon [at] twoshortplanks.com>

Agradecimentos especiais ao Bruno C. Buss pelas idias e colaboraes, e a todo o pessoal do nibus que nos levou at So Paulo na vspera do evento, que nos aturaram madrugada a dentro enquanto terminvamos o desenvolvimento e corrigamos alguns bugs.



=head1 VEJA TAMBM

L<Filter::Simple>, L<Acme::Lingua::Strine::Perl>
L<http://www.tropadeeliteofilme.com.br>



=head1 LICENA E COPYRIGHT

Copyright 2008 Breno, Fernando. Todos os direitos reservados.

Este mdulo  software livre; voc pode redistribu-lo e/ou modific-lo sob os mesmos termos que o Perl em si. Veja L<perlartistic>.



=head1 GARANTIA

Nenhuma. Eu hein...
